;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-advanced-reader.ss" "lang")((modname battleship-draw) (read-case-sensitive #t) (teachpacks ()) (htdp-settings #(#t constructor repeating-decimal #t #t none #f ())))
(require 2htdp/image)
(require "battleship-data.rkt")
(require "provide.rkt")
(provide draw-board)

;; n-copies : nat (image image -> image) image
(define (n-copies n combine i)
  (cond
    [(zero? n) empty-image]
    [else (combine i (n-copies (sub1 n) combine i))]))

(define gray-peg (circle (/ CELL-SIZE 3)  "solid" "gray"))
(define plain-cell (overlay gray-peg
                            (rectangle CELL-SIZE CELL-SIZE  "solid" "blue")))
(define red-peg (circle (/ CELL-SIZE 3)  "solid" "red"))
(define white-peg (circle (/ CELL-SIZE 3)  "solid" "white"))
(define boat-cell (rectangle CELL-SIZE CELL-SIZE  "solid" "gray"))

(define transparent-view (rectangle (* COLS CELL-SIZE) (* ROWS CELL-SIZE)  "outline" "blue"))

(define plain-view
  (n-copies ROWS
            above
            (n-copies COLS beside plain-cell)))

;; draw-posn : posn image -> image
;;  To put the image i at the right relative location
;;  in the result image
(define (draw-posn p i)
  (overlay/xy i
              (- (* CELL-SIZE (posn-x p)))
              (- (* CELL-SIZE (posn-y p)))
              transparent-view))

;; draw-apeg : apeg -> image
(define (draw-apeg a)
  (draw-posn (apeg-loc a)
             (overlay
              (if (apeg-hit? a) red-peg white-peg)
              plain-cell)))

;; draw-hpeg : hpeg -> image
(define (draw-hpeg a)
  (draw-posn (hpeg-loc a)
             (overlay
              (if (hpeg-hit? a) red-peg gray-peg)
              plain-cell)))

;; draw-list : list-of-X image (X -> image) -> image
(define (draw-list draw-elem base-view a)
  (cond
    [(empty? a) base-view]
    [(cons? a) (overlay (draw-elem (first a))  
                        (draw-list draw-elem base-view (rest a)))]))

;; draw-away : away-view -> image
(define (draw-away a)
  (draw-list draw-apeg plain-view a))

;; old-draw-boat : boat -> image
(define (old-draw-boat b)
  (draw-list draw-hpeg transparent-view b))

;; last : non-empty-list-of-X -> X
(define (last l)
  (cond
    [(empty? (rest l)) (first l)]
    [else (last (rest l))]))

;; draw-boat : boat -> image
(define (draw-boat b)
  (overlay
   (local [(define start (first b))
           (define end (last b))
           (define s-posn (hpeg-loc start))
           (define e-posn (hpeg-loc end))]
     (draw-posn s-posn
                (rectangle (* CELL-SIZE (+ 1 (- (posn-x e-posn) (posn-x s-posn))))
                           (* CELL-SIZE (+ 1 (- (posn-y e-posn) (posn-y s-posn))))
                           "outline"
                           "white")))
   (old-draw-boat b)))

;; draw-home : home-view -> image
(define (draw-home h)
  (draw-list draw-boat plain-view h))

;; draw-board : board -> image
(define (draw-board b)
  (above (draw-away (board-away b)) 
         (rectangle 10 10 "solid" (if (board-my-turn? b)
                                      "red" 
                                      "white"))
         (draw-home (board-home b))))
